#ifndef        __GMDRV_H__
#define        __GMDRV_H__

#include "ddriver.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h> 
#include <setjmp.h>
#include <X11/keysym.h>
#include <stdlib.h>
/*
struct GMMode : public ScreenMode
{
  GMMode( int w,
	  int h,
	  int bbl,
	  os::ColorSpace cs,
	  int mode,
	  uint32 fb ) : ScreenMode( w,h,bbl,cs ) { m_nVesaMode = mode; m_nFrameBuffer = fb; }
  int		m_nVesaMode;
  uint32	m_nFrameBuffer;
};
*/
class GMDriver : public DisplayDriver
{
 public:
  sem_id mysem;
  
  GMDriver();
  ~GMDriver();
  
  area_id	    	       	Open();
  void			       	Close();
  
  virtual int			GetScreenModeCount();
  virtual bool			GetScreenModeDesc( int nIndex, ScreenMode* psMode );

  int		       		SetScreenMode( int nWidth,
					       int nHeight,
					       os::ColorSpace eColorSpc,
					       int nPosH,
					       int nPosV,
					       int nSizeH,
					       int nSizeV, float vRefreshRate );

  virtual int				GetHorizontalRes();
  virtual int				GetVerticalRes();
  virtual int				GetBytesPerLine();
  virtual os::ColorSpace	GetColorSpace();
  virtual int				GetFramebufferOffset() { return( m_nFrameBufferOffset ); }
  
  void					SetColor( int nIndex, const os::Color32_s& sColor );
  
  bool					IntersectWithMouse( const os::IRect& cRect );
  
  bool					DrawLine( SrvBitmap* psBitMap, const os::IRect& cClipRect,
						  const os::IPoint& cPnt1, const os::IPoint& cPnt2, const os::Color32_s& sColor, int nMode );
  bool					FillRect( SrvBitmap* psBitMap, const os::IRect& cRect, const os::Color32_s& sColor );
  bool					BltBitmap( SrvBitmap* pcDstBitMap, SrvBitmap* pcSrcBitMap, os::IRect cSrcRect, os::IPoint cDstPos, int nMode );
  
  bool        RenderGlyph( SrvBitmap* pcBitmap, Glyph* pcGlyph, const os::IPoint& cPos,
			   const os::IRect& cClipRect, uint32* anPalette );
  bool        RenderGlyph( SrvBitmap* pcBitmap, Glyph* pcGlyph, const os::IPoint& cPos,
			   const os::IRect& cClipRect, const os::Color32_s& sFgColor );
  Display *display;
  void Refresh(int posx,int posy, int width,int height);
  bool busy;

 private:
  
 int c;
 bool					InitModes();
 bool					SetVesaMode( uint32 nMode );
 
 int						m_nCurrentMode;
 uint32					m_nFrameBufferSize;
 int						m_nFrameBufferOffset;
 std::vector<ScreenMode>	m_cModeList;
 
 int screen;
 Window xcanvas;
 int depth;
 XImage *image;
 
 Colormap colormap;
 GC image_gc;
 unsigned short int *buffer_16bpp;
 char *buffer_32bpp;
 XImage *xim;


 XSetWindowAttributes window_attributes;
 unsigned long window_mask;
 XSizeHints window_hints;
 Pixmap mon_pixmap;

 sem_id refreshsem;

};

#endif // __VESADRV_H__
